
SCRAMBLE.SCR

Scr # 0 
  0 \ SCRAMBLE - Information                                         
  1                                                                  
  2 SCRAMBLE is a file encryption program for IBM-PC or compatible   
  3 computers.  Requires DOS 2.0 or greater.                         
  4                                                                  
  5 This program is placed in the public domain by the author.       
  6                                                                  
  7 3 July 1992                                                      
  8                                                                  
  9 1-Jun-01 - modified for DX-FORTH 2                               
 10                                                                  
 11                                                                  
 12                                                                  
 13                                                                  
 14                                                                  
 15                                                                  

Scr # 1 
  0 \ SCRAMBLE - Load screen                                         
  1 FORTH DEFINITIONS DECIMAL                                        
  2 APPLICATION                                                      
  3                                                                  
  4 CR .( Compiling... )                                             
  5 2 15 THRU                                                        
  6                                                                  
  7 CR .( Save to disk? ) Y/N [IF]                                   
  8   TURNKEY MAIN SCRAMBLE  [THEN]                                  
  9                                                                  
 10                                                                  
 11                                                                  
 12                                                                  
 13                                                                  
 14                                                                  
 15                                                                  

Scr # 2 
  0 \ SCRAMBLE - HELLO DOS-QUIT DOS-ERROR                            
  1                                                                  
  2 : HELLO  CR ." SCRAMBLE version 1.0  1-Jun-01" CR ;              
  3                                                                  
  4 \ : BEEP 7 EMIT ;                                                
  5                                                                  
  6 \ Error encountered, quit with return code of 1                  
  7 : ERROR ( -- )                                                   
  8   CR  1 RETURN ;                                                 
  9                                                                  
 10                                                                  
 11                                                                  
 12                                                                  
 13                                                                  
 14                                                                  
 15                                                                  
SCRAMBLE.SCR

Scr # 3 
  0 \ SCRAMBLE - System buffers, constants, variables                
  1 \ Allocate buffers                                               
  2 CREATE INFILE   65 ALLOT        \ input path/filename            
  3 CREATE PASSWORD  8 ALLOT        \ password                       
  4                                                                  
  5 VARIABLE  HNDL                  \ hold infile handle             
  6 VARIABLE  EXFLAG                \ extend file flag               
  7 VARIABLE  TDFLAG                \ time/date flag                 
  8 2VARIABLE CPOS                  \ current file position          
  9 2VARIABLE LPOS                  \ last file position             
 10 2VARIABLE TIME-DATE             \ file time/date stamp           
 11                                                                  
 12 \ read/write buffer must be a multiple of 1024 bytes             
 13 : BUFSIZE  ( -- u ) UNUSED 10 RSHIFT  2-  10 LSHIFT ;            
 14                                                                  
 15                                                                  

Scr # 4 
  0 \ SCRAMBLE - HELP                                                
  1 \ Display help message and exit                                  
  2 : HELP ( -- )                                                    
  3   CR ." Usage:  SCRAMBLE [path\]filename password [-options]"    
  4   CR CR ."   e   extend file to an even 1024 byte length"        
  5   CR    ."   d   set file to current time and date."             
  6   CR CR ." Scramble a file using an 8 character password."       
  7   CR ." Scrambling is done in place, i.e. the file is modified"  
  8   CR ." on top of itself.  The same password used to scramble"   
  9   CR ." the file is used to unscramble it - using the same"      
 10   CR ." command.  The password may not contain blanks, tabs or"  
 11   CR ." control characters.  Compatible with CP/M SCRAMBLE."     
 12   CR CR  18 SPACES  ." DX-FORTH 2"                               
 13   ERROR ;                                                        
 14                                                                  
 15                                                                  

Scr # 5 
  0 \ SCRAMBLE - GETSTAMP SETSTAMP ARGV                              
  1 HEX                                                              
  2 CODE GETSTAMP  ( handle -- date time flag )                      
  3   BX POP  5700 # AX MOV  21 INT                                  
  4   DX PUSH  CX PUSH  PUSHF  NEXT  END-CODE                        
  5 CODE SETSTAMP  ( date time handle -- flag )                      
  6   BX POP  CX POP  DX POP  5701 # AX MOV  21 INT                  
  7   PUSHF  NEXT  END-CODE                                          
  8 DECIMAL                                                          
  9                                                                  
 10 \ Parse blank delimited argument from commandline.               
 11 : ARGV  ( n -- adr u -1 | 0 )                                    
 12   0 0 ROT  128 COUNT  ROT 0 ?DO                                  
 13     2SWAP 2DROP  BL SKIP  2DUP BL SCAN                           
 14     ROT OVER -  ROT ROT  LOOP                                    
 15   2DROP DUP IF -1 ELSE AND THEN ;                                
SCRAMBLE.SCR

Scr # 6 
  0 \ SCRAMBLE - CHECKDUP                                            
  1 \ Check password for more than 2 duplicated chars                
  2 : CHECKDUP  ( char -- )                                          
  3   [ 2 1+ ] LITERAL  SWAP                                         
  4   PASSWORD 8  OVER + SWAP  DO                                    
  5     I C@  ( max char c )  OVER =  IF  ( duplicated )             
  6       SWAP 1- SWAP  OVER 0= IF                                   
  7         ." ++ No character may appear more than twice in "       
  8         ." password."  CR  [CHAR] ' EMIT  ( char ) EMIT          
  9         ." ' does in yours ++"  ERROR  THEN                      
 10       THEN                                                       
 11     LOOP                                                         
 12   2DROP ;                                                        
 13                                                                  
 14                                                                  
 15                                                                  

Scr # 7 
  0 \ SCRAMBLE - GETPW                                               
  1 \ Get password                                                   
  2 : GETPW  ( -- )                                                  
  3   2 ARGV                                \ parse password         
  4   0= IF HELP THEN                       \ show help if none      
  5   8 - IF                                \ check length           
  6     ." ++ Password not 8 characters ++" ERROR  THEN              
  7   PASSWORD 8 CMOVE                      \ store it               
  8   PASSWORD 8  2DUP UPPER                \ make uppercase         
  9   OVER + SWAP  DO                                                
 10     I C@  CHECKDUP                      \ check dup character    
 11   LOOP ;                                                         
 12                                                                  
 13                                                                  
 14                                                                  
 15                                                                  

Scr # 8 
  0 \ SCRAMBLE - GETFNAME SETOPT                                     
  1 \ Parse input filename                                           
  2 : GETFNAME  ( -- )                                               
  3   1 ARGV                                \ parse filename         
  4   0= IF HELP THEN                       \ show help if none      
  5   64 MIN  INFILE PLACE ;                \ store it               
  6                                                                  
  7 \ Set the option                                                 
  8 : SETOPT  ( char -- )                                            
  9   UPCASE                                                         
 10   CASE  [CHAR] E  OF  1 EXFLAG !  ENDOF  \ extend option         
 11         [CHAR] D  OF  1 TDFLAG !  ENDOF  \ current time/date opt 
 12   ." ++ Unknown option ++" ERROR         \ exit if none of above 
 13   ENDCASE ;                                                      
 14                                                                  
 15                                                                  
SCRAMBLE.SCR

Scr # 9 
  0 \ SCRAMBLE - GETOPT                                              
  1 \ Get option list, processing each                               
  2 : GETOPT  ( -- )                                                 
  3   EXFLAG OFF  TDFLAG OFF                \ clear options          
  4   3 ARGV                                \ parse next word        
  5   0= IF  EXIT  THEN                     \ no option, exit        
  6   OVER C@ DUP [CHAR] -  =               \ check switch '-'       
  7   SWAP [CHAR] / = OR                    \ or '/'                 
  8   OVER 1 >                              \ minimum length of 2    
  9   AND 0= IF HELP THEN                                            
 10   OVER + SWAP 1+  DO                    \ loop thru each option  
 11     I C@ SETOPT                         \ setting it             
 12   LOOP ;                                                         
 13                                                                  
 14                                                                  
 15                                                                  

Scr # 10 
  0 \ SCRAMBLE - OPENF CLOSEF                                        
  1 \ Open input file                                                
  2 : OPENF  ( -- )                                                  
  3   INFILE COUNT  R/W OPEN-FILE  IF       \ open for read/write    
  4     5 = IF  ." ++ Access denied ++"                              
  5       ELSE  ." ++ File not found ++"  THEN  ERROR THEN           
  6   DUP HNDL !                            \ save file handle       
  7   GETSTAMP DROP  TIME-DATE 2!           \ save file stamp        
  8   0 0 2DUP  LPOS 2!  CPOS 2! ;          \ reset pointers         
  9 \ Close the file                                                 
 10 : CLOSEF  ( -- )                                                 
 11   TDFLAG @  0= IF                       \ restore old stamp      
 12     TIME-DATE 2@  HNDL @ SETSTAMP DROP  THEN                     
 13   HNDL @ CLOSE-FILE  IF                 \ close file             
 14     ." ++ Close error - file left in unknown condition ++"       
 15     BEEP ERROR  THEN ;                                           

Scr # 11 
  0 \ SCRAMBLE - READF                                               
  1 \ Read input file into buffer                                    
  2 : READF  ( adr u1 -- u2 )                                        
  3   2DUP ERASE                            \ zero-fill buffer       
  4   HNDL @ READ-FILE  IF                  \ read block             
  5     CR ." ++ Read error - file may be destroyed ++"              
  6     BEEP ERROR  THEN                                             
  7   EXFLAG @ IF                           \ if extend flag set and 
  8     DUP [ HEX ] 03FF AND IF             \ partial block ie. eof  
  9       0FC00 AND  400 + [ DECIMAL ] THEN \ then round to next 1k  
 10     THEN                                                         
 11   DUP 0                                 \ convert to double      
 12   CPOS 2@  2DUP LPOS 2!                 \ update 'last' pointer  
 13   D+  CPOS 2! ;                         \ update 'current' pntr  
 14                                                                  
 15                                                                  
SCRAMBLE.SCR

Scr # 12 
  0 \ SCRAMBLE - WERROR WRITEF                                       
  1 \ Write error encountered                                        
  2 : WERROR  ( -- )                                                 
  3   ."  - file is corrupted ++" BEEP ERROR ;                       
  4                                                                  
  5 \ Over-write the block of data just read                         
  6 : WRITEF  ( adr #bytes -- )                                      
  7   LPOS 2@  HNDL @ REPOSITION-FILE  IF           \ backup pointer 
  8     CR ." ++ Seek error"  WERROR  THEN                           
  9   HNDL @  WRITE-FILE  IF                        \ write block    
 10     CR ." ++ Write error"  WERROR  THEN ;                        
 11                                                                  
 12                                                                  
 13                                                                  
 14                                                                  
 15                                                                  

Scr # 13 
  0 \ SCRAMBLE - ENCRYPT                                             
  1 HEX                                                              
  2 CODE ENCRYPT  ( adr u -- )                                       
  3 CX POP  AX POP  SI PUSH  AX SI MOV  PASSWORD # BX MOV            
  4 1 $:                                                             
  5   4 # DL MOV  2 $: CLC                                           
  6     0 [BX] AX MOV  AL RCR  AH RCR  AX 0 [BX] MOV                 
  7     2 [BX] AX MOV  AL RCR  AH RCR  AX 2 [BX] MOV                 
  8     4 [BX] AX MOV  AL RCR  AH RCR  AX 4 [BX] MOV                 
  9     6 [BX] AX MOV  AL RCR  AH RCR  AX 6 [BX] MOV                 
 10     CLC  AH RCR  AH RCR  7 [BX] AH XOR  AH ROR                   
 11     80 # AH AND  0 [BX] AH OR  AH 0 [BX] MOV                     
 12     DL DEC  2 $ JNZ                                              
 13   AH 0 [SI] XOR  SI INC  CX DEC  1 $ JNZ                         
 14 SI POP  NEXT  END-CODE                                           
 15 DECIMAL                                                          

Scr # 14 
  0 \ SCRAMBLE - SCRAMBLE-FILE                                       
  1 \ Read file, scramble it and write it out again                  
  2 : SCRAMBLE-FILE  ( -- )                                          
  3   OPENF                             \ open the file              
  4   BEGIN                                                          
  5     PAD                             \ start addr file buffer     
  6     DUP BUFSIZE READF  ?DUP         \ read block, #bytes read    
  7   WHILE ( not end )                                              
  8     [CHAR] .  EMIT                  \ show progress              
  9     2DUP  ENCRYPT                   \ encrypt block              
 10     WRITEF                          \ write block                
 11   REPEAT                            \ loop for more              
 12   DROP  CR                                                       
 13   CLOSEF ;                          \ close the file             
 14                                                                  
 15                                                                  
SCRAMBLE.SCR

Scr # 15 
  0 \ SCRAMBLE - MAIN                                                
  1                                                                  
  2 : MAIN  ( -- )                                                   
  3   HELLO                         \ program name and version       
  4   GETFNAME GETPW GETOPT         \ get filename, password, option 
  5   SCRAMBLE-FILE ;               \ scramble the file              
  6                                                                  
  7                                                                  
  8                                                                  
  9                                                                  
 10                                                                  
 11                                                                  
 12                                                                  
 13                                                                  
 14                                                                  
 15                                                                  

Scr # 16 
  0                                                                  
  1                                                                  
  2                                                                  
  3                                                                  
  4                                                                  
  5                                                                  
  6                                                                  
  7                                                                  
  8                                                                  
  9                                                                  
 10                                                                  
 11                                                                  
 12                                                                  
 13                                                                  
 14                                                                  
 15                                                                  

Scr # 17 
  0                                                                  
  1                                                                  
  2                                                                  
  3                                                                  
  4                                                                  
  5                                                                  
  6                                                                  
  7                                                                  
  8                                                                  
  9                                                                  
 10                                                                  
 11                                                                  
 12                                                                  
 13                                                                  
 14                                                                  
 15                                                                  